import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Timer;
import javax.vecmath.*;

import java.io.BufferedReader;
import java.io.FileReader;


public class MultipleRobotInterface {


	static int robotNum=5;
	static MultipleRobotSimulator mySim = new MultipleRobotSimulator();
	static LeftWallFollowing[] leftWall= null;

	static GUIFrame myFrame;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		System.out.println("start");

		//設定ファイルからデータを読み取る
		//設定ファイル名
		String filename ="robot.conf";
		//ファイル読込ストリーム
		BufferedReader br;
		//読み取り文字列
		String readString="";
		//行数
		int dataRow=0;

		try{
			//ファイルにアクセス
			br = new BufferedReader(new FileReader(filename));
			while(readString !=null){
				//一行ずつ読み取り
				readString =br.readLine();
				if(readString !=null){
					//Endがあれば終了
					if(readString.equals("End"))	break;
					char[] readChar = readString.toCharArray();
					if(readChar[0] != '%'){	//コメント行をはじく
						//最初の一行はフロントエンドのＩＰアドレス
						if(dataRow==0)	robotNum = Integer.parseInt(readString);

						dataRow++;
					}
				}
			}
		}catch(Exception eFile){
			System.out.println(eFile.toString());
			System.out.println("ロボット台数を5台でスタートします");
			robotNum=5;
		}


		//シミュレータの起動
		//シミュレータの初期設定
		mySim.robotNum=robotNum;


		//JoyStickの取得開始
//		JoyClass.openDevice();

		//GUI起動
		myFrame=new GUIFrame();
		myFrame.setLocation(480, 0);

		myFrame.mapPanel.robotNum=robotNum;

		myFrame.mapPanel.robotData = new MapRobotData[myFrame.mapPanel.robotNum];
		for(int i=0;i<myFrame.mapPanel.robotNum;i++){
			myFrame.mapPanel.robotData[i] = new MapRobotData();
		}
		for(int i=0;i<robotNum;i++){
			myFrame.mapPanel.robotData[i].posdata=new Point3d((double)myFrame.mapPanel.robotRadius*2.3*(-i),0,0);
		}
		//For Test
//		myFrame.mapPanel.robotData[0].posdata=new Point3d(500,0,0);
//		myFrame.mapPanel.robotData[1].posdata=new Point3d(100,400,0);
//		myFrame.mapPanel.robotData[2].posdata=new Point3d(200,-300,0);
//		myFrame.mapPanel.robotData[3].posdata=new Point3d(-400,200,0);
//		myFrame.mapPanel.robotData[4].posdata=new Point3d(-200,-500,0);

		//左手法
//		leftWall= new LeftWallFollowing[robotNum];
//		for(int i=0;i<robotNum;i++){
//			leftWall[i] = new LeftWallFollowing();
//		}

		//スレッドの開始
		Thread simulatorThread = new Thread(mySim);
		simulatorThread.start();

		//描画更新タイマー
		Timer displayTimer = new Timer(50,new ActionListener(){
			public void actionPerformed(ActionEvent event){
				myFrame.mapPanel.robotNowUrgPoint = new Point2d[robotNum][];
//				System.out.println("-----------------------------------------------------");
				for(int i=0;i<robotNum;i++){
					//自己位置をシミュレータから渡す
					if(mySim.robotPosition != null){
						if(mySim.robotPosition[i] != null){
							myFrame.mapPanel.robotData[i].posdata = new Point3d(mySim.robotPosition2[i].x,mySim.robotPosition2[i].y,mySim.robotPosition2[i].z);
						}
					}

					//LRFデータをパネルに渡す
					if(mySim.lrfDataGlobal != null){
						if(mySim.lrfDataGlobal[i] != null){
							myFrame.mapPanel.robotNowUrgPoint[i] = new Point2d[mySim.lrfDataGlobal[i].length];
							for(int j=0;j<mySim.lrfDataGlobal[i].length;j++){
								if(mySim.lrfDataGlobal[i][j] != null){
									myFrame.mapPanel.maxLrfDistance=(int)(mySim.myEnv.robots[i].maxDistance*1000.0);
									myFrame.mapPanel.robotNowUrgPoint[i][j]= new Point2d(mySim.lrfDataGlobal2[i][j].x, mySim.lrfDataGlobal2[i][j].y);
								}
							}
						}
					}
					if(mySim.velData != null){
						if(mySim.velData[i] !=null){
							//速度をシミュレータに渡す
//							double vJoy=-JoyClass.axisValue[1]/200.0;
//							double wJoy=-JoyClass.axisValue[2]/200.0;
//							mySim.velData[i]=new Point2d(vJoy,wJoy);

							//左手法
//							System.out.print("robot "+i+" --> ");
//							Point2d leftVel = leftWall[i].calcVelocity(mySim.lrfDataRobot[i], false);
//							mySim.velData[i]=new Point2d(leftVel.x, leftVel.y);
						}
					}
					if(myFrame.mapPanel.robotData[i]!=null){
						if(myFrame.mapPanel.robotData[i].posdata !=null){
							if(myFrame.mapPanel.groupData !=null){
								if(myFrame.mapPanel.robotData[i].groupID !=-1){
									if(myFrame.mapPanel.groupData[myFrame.mapPanel.robotData[i].groupID] !=null){
										if(myFrame.mapPanel.groupData[myFrame.mapPanel.robotData[i].groupID].targetTrajectry !=null){
											if(mySim.velData[i] !=null){
												VirtualTargetFollowing vtf = new VirtualTargetFollowing();

												mySim.velData[i] = vtf.getVelocity(myFrame.mapPanel.robotData[i].posdata, myFrame.mapPanel.groupData[myFrame.mapPanel.robotData[i].groupID].targetTrajectry, mySim.velData[i], mySim.lrfDataRobot[i]);
												//速度をパネルに渡す
												myFrame.mapPanel.robotData[i].velocity = new Point2d(mySim.velData[i].x, mySim.velData[i].y);
											}
										}
									}
								}
							}
						}
					}
				}
				myFrame.mapPanel.repaint();
			}
		});
		displayTimer.start();

		//インタフェースGUIの表示開始
		myFrame.setVisible(true);
//		myFrame.mapPanent();
	}
}